#!/bin/bash -l

#SBATCH -J AbaqusUMatCheck
#SBATCH -A myaccount
#SBATCH --nodes=1
#SBATCH --time=00:05:00
#SBATCH -p cpu
#SBATCH --qos test
# disable multithreading. Please check both cases to see which gives better performance
#SBATCH --hint=nomultithread
#SBATCH --ntasks-per-node=128
#SBATCH --cpus-per-task=1
#SBATCH -o %x-%j.log

### Load ABAQUS module
module load abaqus/2023
module load intel-compilers

### Configure environment variables, need to unset SLURM's Global Task ID for ABAQUS's PlatformMPI to work
unset SLURM_GTIDS

### Set input file and job (file prefix) name here
job_name=${SLURM_JOB_NAME}

abaqus job=${job_name} input=CDIE_1E.inp user=UCrys_HCP_Only double=both interactive